#include "robot.h"
#include <bits/stdc++.h>

/**
states:
-2 : border
-1 : can not enter
0 : unvisited
1 : path to goal
2 : starting point marked for traversal
3 : starting point gone through

4 : come from north / marked for traversal
5 : come from east /
6 : come from south /
7 : come from west /

8 : come from north / gone through
9 : come from east / gone through
10 : come from south / gone through
11 : come from west / gone through

*/

const int MARKED = 253, GONE = 133, OBSTACLE = 173, NOTHING = 83;
char dir[4] = {'W', 'S', 'E', 'N'};
int rev[4] = {2, 3, 0, 1};
int group(int state)
{
    if ((state >= 4 && state <= 7))
        return MARKED;
    if ((state >= 8 && state <= 11))
        return GONE;
    if (state < 0)
        return OBSTACLE;
    if (state == 0)
        return NOTHING;
    //std::cout << "state " << state << std::endl;
    ///assert(false);
    return 0;
}


void solve_case(int centre, int left, int down, int right, int up)
{
    //std::cout << "solve_case " << centre << " " << left << " " << down << " " << right << " " << up << std::endl;
    if (centre < 0 || centre == 1)
        return;

    bool root = false;
    if (up == -2 && left == -2)
        root = true;
    std::vector < int > nb;
    nb.push_back(left);
    nb.push_back(down);
    nb.push_back(right);
    nb.push_back(up);
    std::vector < int > state = {centre, left, down, right, up};

    bool done = false;
    for (int i = 0; i < 4; i ++)
        if (nb[i] == 1)
            done = true;

    if (done)
    {
        if (root)
        {
            set_instruction(state, 1, 'T');
            return;
        }

        //assert(nb[centre % 4] >= 0);
        
        set_instruction(state, 1, dir[centre % 4]);
        return;
    }
    //std::cout << "STILL INSIDE\n";
    if (right == -2 && down == -2)
    {
        int par = centre % 4;
        if (centre == 0)
        {
            for (int i = 0; i < 4; i ++)
            {
                if (group(nb[i]) == GONE)
                    par = i;
            }
        }

        set_instruction(state, 1, dir[par]);
        return;
    }

    if (centre == 0)
    {
        bool initial = true;
        for (int u : nb)
        {
            if (u > 0)
                initial = false;
        }

        if (initial)
        {
            set_instruction(state, 4, 'H');
            return;
        }     

        for (int i = 0; i < 4; i ++)
        {
            if (group(nb[i]) == GONE)
            {   
                set_instruction(state, i + 8, dir[i]);
                return;
            }
        }    
        //if (centre == 0 && left == 8 && down == 0 && right == 0 && up == -2)
          //  std::cout << "HERE! " << std::endl;
        for (int i = 0; i < 4; i ++)
        {
            if (group(nb[i]) == MARKED)
            {
                set_instruction(state, i + 8, dir[i]);
                return;
            }
        }
        return;
        
        assert(false);
    }



    if (root)
    {
        if (centre >= 4 && centre < 8)
        {
            for (int i = 0; i < 4; i ++)
            {
                if (group(nb[i]) == GONE)
                {
                    set_instruction(state, centre, dir[i]);
                    return;
                }
            }

            set_instruction(state, centre + 4, 'H');
            return;
        }
        if (centre >= 8 && centre < 12)
        {
            for (int i = 0; i < 4; i ++)
            {
                if (nb[i] == 0 || group(nb[i]) == MARKED)
                {
                    set_instruction(state, centre, dir[i]);
                    return;
                }
            }
            set_instruction(state, centre - 4, 'H');
            return;
        }

        return;
    }

    int par = centre % 4;
    if (group(nb[par]) == MARKED)
    {         
        for (int i = 0; i < 4; i ++)
        {/**if (centre == 7 && left == -2 && down == 11 && right == 4 && up == 2)
        {
            //std::cout << "HERE " << new_state << " " << dir[i] << std::endl;
            std::cout << "HERE " << std::endl;
            std::cout << nb[1] << " " << rev[nb[1] % 4] << std::endl;
            exit(0);
        }*/

            if ((nb[i] >= 8 && rev[nb[i] % 4] == i))
            {        
                int new_state = centre;
                if (group(centre) == GONE)
                    new_state -= 4;
                assert(new_state >= 0 && new_state <= 19);
                
                set_instruction(state, new_state, dir[i]);
                return;
            }
        }
        int new_state = centre;
        if (group(new_state) == GONE)
            new_state -= 4;
        assert(new_state >= 0 && new_state <= 19);
        set_instruction(state, new_state, dir[par]);
        return;
    }

    for (int i = 0; i < 4; i ++)
    {
        if (nb[i] == 0 || (nb[i] > 3 && nb[i] < 8 && rev[nb[i] % 4] == i))
        {
            int new_state = centre;
            if (group(centre) == MARKED)
                new_state += 4;
            assert(new_state >= 0 && new_state <= 19);
            set_instruction(state, new_state, dir[i]);
            return;
        }
    }
   
    int new_centre = centre;
    if (group(new_centre) == MARKED)
        new_centre +=4;
    set_instruction(state, new_centre, dir[par]);

}
std::vector < int > state_list;

void program_pulibot()
{
    for (int i = -2; i <= 11; i ++)
        state_list.push_back(i);

    for (int up : state_list)
        for (int right : state_list)
            for (int down : state_list)
                for (int left : state_list)
                    for (int centre : state_list)
                    {
                        solve_case(centre, left, down, right, up);
                    }
    /**set_instruction({0, -2, -1, 0, -2}, 1, 'E');
    set_instruction({0, 1, -1, 0, -2}, 1, 'E');
    set_instruction({0, 1, 0, -2, -2}, 1, 'S');
    set_instruction({0, -1, -2, -2, 1}, 1, 'T');*/
}
