#include "robot.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <set>

typedef long long llong;
const int MAXN = 20;
const int Z_MAX = 17;

struct State
{
    int doneChildren;
    bool haventPassed;
    bool isOutside;
    bool isCross;
    bool isDone;
    char parent;
    
    State()
    {
        isOutside = isCross = isDone = parent = doneChildren = haventPassed = 0;
    }

    int getParNum()
    {
        if (parent == 'W') return 0;
        if (parent == 'S') return 1;
        if (parent == 'E') return 2;
        if (parent == 'N') return 3;
        std::cout << "parent is: " << (int)parent << ' ' << parent << '\n' << std::flush;
        assert(false);
    }

    char byParNum(int num)
    {
        if (num == 0) return 'W';
        if (num == 1) return 'S';
        if (num == 2) return 'E';
        if (num == 3) return 'N';
        assert(false);
    }


    int getNUM()
    {
        if (isDone) return 1;
        if (isOutside) return -2;
        if (isCross) return -1;
        if (haventPassed) return 0;
        return getParNum() * 4 + doneChildren + 2; // zMAX == 19
    }

    void setState(int num)
    {
        isOutside = isCross = isDone = parent = doneChildren = haventPassed = 0;
        if (num == -2)
        {
            isOutside = 1;
            return;
        }

        if (num == -1)
        {
            isCross = 1;
            return;
        }

        if (num == 0)
        {
            haventPassed = 1;
            return;
        }

        if (num == 1)
        {
            isDone = 1;
            return;
        }
        
        assert(num <= 17);
        num -= 2;
        doneChildren = num % 4;
        parent = byParNum(num  / 4);
    }
};

State state[5];
std::vector <int> nums;

bool isNeighboor[5];
char getDirection[4] = {'W', 'S', 'E', 'N'};
char getOpposite[4] = {'E', 'N', 'W', 'S'};

void rec(int idx)
{
    if (idx == 5)
    {
        if (state[0].isCross || state[0].isOutside || state[0].isDone)
        {
            return;
        }

        int countUnvisited = 0;
        for (int i = 0 ; i < 5 ; ++i)
        {
            countUnvisited += state[i].haventPassed;
        }

        if (state[1].isOutside && state[4].isOutside && state[0].parent != 'N')
        {
            State newState = state[0];
            newState.haventPassed = 0;
            newState.parent = 'N';
            newState.doneChildren = 0;
            assert(newState.parent != 0);
            set_instruction(nums, newState.getNUM(), 'H');
            return;
        }

        bool isOne = 0;
        for (int i = 1 ; i < 5 ; ++i)
        {
            isOne |= state[i].isDone;
        }

        if (isOne || (state[2].isOutside && state[3].isOutside))
        {                
            State newState = state[0];
            newState.isDone = 1;

            if (state[2].isOutside && state[3].isOutside)
            {
                for (int i = 1 ; i < 5 ; ++i)
                {
                    if (!state[i].haventPassed && !state[i].isCross && !state[i].isOutside)
                    {                        
                        newState.parent = getDirection[i - 1];
                        break;
                    }
                }
            }
            
            if (newState.parent == 0)
            {
                return;
            }

            assert(newState.getNUM() == 1);
            set_instruction(nums, newState.getNUM(), ((state[1].isOutside && state[4].isOutside) ? 'T' : newState.parent));
            return;
        }

        if (!state[0].haventPassed)
        {
            int cntNeighboors = 0;
            for (int i = 1 ; i < 5 ; ++i)
            {
                isNeighboor[i] = !state[i].isOutside && !state[i].isCross && (state[i].haventPassed || state[i].parent == getOpposite[i - 1]);
                cntNeighboors += isNeighboor[i];
            }
            
            if (cntNeighboors > 2 || cntNeighboors == 0)
            {
                return;
            }

            if (state[0].doneChildren == cntNeighboors)
            {
                State newState = state[0];
                newState.doneChildren = 0;
                assert(newState.parent != 0);
                set_instruction(nums, newState.getNUM(), ((state[1].isOutside && state[4].isOutside) ? 'H' : newState.parent));
                return;
            } else
            {
                int choose = state[0].doneChildren;
                for (int i = 1 ; i < 5 ; ++i)
                {
                    if (choose < isNeighboor[i])
                    {
                        State newState = state[0];
                        newState.doneChildren++;
                        assert(newState.parent != 0);
                        set_instruction(nums, newState.getNUM(), getDirection[i - 1]);
                        return;
                    }

                    choose -= isNeighboor[i];
                }
            }
        } else
        {
            State newState;
            for (int i = 1 ; i < 5 ; ++i)
            {
                if (!state[i].haventPassed && !state[i].isCross && !state[i].isOutside)
                {
                    newState.parent = getDirection[i - 1];
                    break;
                }
            }

            if (newState.parent == 0)
            {
                return;
            }

            newState.haventPassed = 0;
            newState.doneChildren = 0;
            assert(newState.parent != 0);
            set_instruction(nums, newState.getNUM(), newState.parent);
            return;
        }
    
        return;
    }

    for (int curr = -2 ; curr <= Z_MAX ; ++curr)
    {
        state[idx].setState(curr);
        nums[idx] = curr;
        rec(idx + 1);
    }
}

void program_pulibot()
{
    nums.resize(5);
    rec(0);
}